package com.jisco.dynamicweight.dynamicbasebatchstation.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasebatchstation.model.DynamicBaseBatchStation;
import com.jisco.dynamicweight.dynamicbasebatchstation.service.IDynamicBaseBatchStationService;
import com.jisco.dynamicweight.dynamicbasereciever.model.DynamicBaseReciever;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.baseinfo.meterbasecalibrarelation.model.MeterBaseCalibraRelation;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.*;

/**
 * DynamicBaseBatchStation RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-05 11:28
 * 类描述
 * 修订历史：
 * 日期：2022-01-05
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseBatchStation RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/dynamicbasebatchstations")
public class DynamicBaseBatchStationController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseBatchStationService dynamicBaseBatchStationService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasebatchstation:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseBatchStation> list = dynamicBaseBatchStationService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasebatchstation:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseBatchStation> list = dynamicBaseBatchStationService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据DynamicBaseBatchStation对象创建")
    @ApiImplicitParam(name = "dynamicBaseBatchStation", value = "详细实体dynamicBaseBatchStation", required = true, dataType = "DynamicBaseBatchStation")
    //@RequiresPermissions("dynamicbasebatchstation:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseBatchStation model){
        Assert.isTrue(StringUtils.isNotBlank(model.getStationName()), "请输入皮带秤名称!");
        Assert.isTrue(StringUtils.isNotBlank(model.getStationCode()), "请输入皮带秤编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getPikaCode()), "请输入PIKA系统编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        Assert.isTrue(Objects.nonNull(model.getIsUpload()), "请选择是否上传!");
        Assert.isTrue(Objects.nonNull(model.getIsInbatches()), "请选择是否分批!");
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseBatchStation dynamicBaseBatchStation = dynamicBaseBatchStationService.add(model);
        return success(dynamicBaseBatchStation);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasebatchstation:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        DynamicBaseBatchStation dynamicBaseBatchStation = dynamicBaseBatchStationService.getById(id);
        return success(dynamicBaseBatchStation);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的dynamicBaseBatchStation信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "dynamicBaseBatchStation", value = "详细实体dynamicBaseBatchStation", required = true, dataType = "DynamicBaseBatchStation")
    })
    //@RequiresPermissions("dynamicbasebatchstation:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseBatchStation model){
        Assert.isTrue(StringUtils.isNotBlank(model.getStationName()), "请输入皮带秤名称!");
        Assert.isTrue(StringUtils.isNotBlank(model.getStationCode()), "请输入皮带秤编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getPikaCode()), "请输入PIKA系统编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        Assert.isTrue(Objects.nonNull(model.getIsUpload()), "请选择是否上传!");
        Assert.isTrue(Objects.nonNull(model.getIsInbatches()), "请选择是否分批!");
        model.setId(id);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseBatchStation dynamicBaseBatchStation = dynamicBaseBatchStationService.modify(model);
        return success(dynamicBaseBatchStation);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasebatchstation:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  dynamicBaseBatchStationService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseBatchStation> list = dynamicBaseBatchStationService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseBatchStation.class, "分料系统站点信息");
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseCalibraRelation> list = dynamicBaseBatchStationService.queryall(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "启用", notes = "启用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/enable/{id}")
    public RESTfulResult enable(@PathVariable String id) {
        boolean flag = dynamicBaseBatchStationService.enable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }

    @ApiOperation(value = "禁用", notes = "禁用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/disable/{id}")
    public RESTfulResult disable(@PathVariable String id) {
        boolean flag = dynamicBaseBatchStationService.disable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }
}
